# -*- coding: utf-8 -*-
#-------------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal PruebaSetting para probar los parametros propios de un canal
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#--------------------------------------------------------------------

from core import logger
from core import config
from core.item import Item

__category__ = "A"
__type__ = "generic"
__title__ = "PruebaSetting"
__channel__ = "pruebasetting"
__language__ = "ES"
__creationdate__ = "20150303"

def isGeneric():
    return True

def mainlist(item):
    itemlist = []
    # Este item abre el cuadro de dialogo con todos los parametros visibles: ...
    # ... channel y action son datos fijos, pero el titulo podemos modificarlo. ...
    # ... El argumento extra esta compuesto por el canal|action que se han de ejecutar cuando se cierre el cuadro de dialogo.
    itemlist.append( Item(title="Abrir parametros...", channel="config_channel" , action="mainlist", extra="pruebasetting|mainlist"))
    
    # Este item llama a una funcion que modifica uno de los parametros del canal:
    itemlist.append( Item(title="Modificar parametro 'hora'", channel=__channel__ , action="set"))
    
    # Este item llama a una funcion que muestra el valor de uno de los parametros del canal:
    itemlist.append( Item(title="Mostrar parametro 'hora'", channel=__channel__ , action="get"))
    
    # Este item llama a una funcion que modifica un parametro oculto: ...
    # ... utilizamos el argumento extra para pasar a la funcion el identificador del parametro
    id_param='maxchannelshide'
    itemlist.append( Item(title="Modificar parametro oculto", channel=__channel__ , action="set2", extra=id_param))
    
    # Este item llama a una funcion que muestra el valor de un parametro oculto:
    itemlist.append( Item(title="Mostrar parametro oculto", channel=__channel__ , action="get2"))
    
    return itemlist
    

def set(item):
    # Funcion que modifica el parametro 'hora' del canal
    import time
    id_parametro='hora'
    nuevo_valor= time.strftime("%X")
    canal= 'pruebasetting'
    config.set_setting(id_parametro, nuevo_valor, canal)


def get(item):
    # Funcion que muestra el valor del parametro 'hora' del canal
    id_parametro='hora'
    canal= 'pruebasetting'
    valor= config.get_setting(id_parametro, canal)
    
    import xbmcgui
    dialog = xbmcgui.Dialog()
    dialog.ok(id_parametro, "El valor de '%s' es: %s" %(id_parametro, valor))
    
def set2(item):
    # Funcion que modifica el parametro pasado como argumento: item.extra
    import xbmcgui
    dialog = xbmcgui.Dialog()
    d = dialog.numeric(0, item.extra)
    if d!='': 
        config.set_setting(item.extra, d, __channel__)
    
def get2(item):
    # Funcion que muestra el valor del parametro oculto 'maxchannelshide'
    valor= config.get_setting('maxchannelshide', __channel__)
    
    import xbmcgui
    dialog = xbmcgui.Dialog()
    dialog.ok('Mostrar oculto', "El valor de 'maxchannelshide' es: %s" %(valor))